<template>
  <select-king ref="selectKing" v-model="selectVal" optionsWidth="500px" placeholder="请选择记录">
    <div class="type-library">
      <el-form size="min" label-width="80px">
        <el-form-item class="mb-0" label="按类型：">
          <div class="clearfix">
            <div class="select-liby float-left" v-for="(item,index) in recordList" :key="index">
              <a
                :class="recordType === item.value ?'active':''"
                @click="setSelect(item)"
              >{{item.name}}</a>
            </div>
          </div>
        </el-form-item>
        <!-- 多选状态显示 start -->
        <el-form-item class="mb-0" label="按底库：" v-if="isCheckBox">
          <div
            class="library-list clearfix"
            v-for="(data,dataindex) in dataBaseDicCheck"
            :key="dataindex"
          >
            <h6 class="m-0 float-left">
              <el-checkbox
                class="alarm-checkBox mb-0"
                @change="(val)=>{checkAll(val,dataindex)}"
                v-model="data.status"
              >{{data.cluName}}</el-checkbox>
              <span class="px-1">></span>
            </h6>
            <div class="clearfix library-content">
              <div
                class="float-left pl-1 alarm-item"
                v-for="(item,index) in data.dblist"
                :key="index"
              >
                <span class="border-left px-1 title"></span>
                <el-checkbox class="alarm-checkBox mb-0" v-model="item.status"></el-checkbox>
                <div class="alarm-icon" v-if="item.personIsHub==='1'">
                  <span class="f10 font-weight-bolder">!</span>
                </div>
                <a
                  :title="item.baseValue"
                  :class="['alarm-name',item && item.status ?'active':'']"
                  @click="setSelectLibrary({ index, val:!!item.status},dataindex);recordType = 'dataBase'"
                >{{item.baseValue}}</a>
              </div>
            </div>
          </div>
          <div class="py-1 text-center">
            <b-btn variant="primary" size="sm" @click="submitCheck" class="mr10">确定</b-btn>
            <b-btn variant="secondary" size="sm" class="mr10" @click="cancel">取消</b-btn>
          </div>
        </el-form-item>
        <!-- 多选状态显示 end -->
        <!-- 单选状态显示 start -->
        <el-form-item class="mb-0" label="按底库：" v-else>
          <div
            class="library-list clearfix"
            v-for="(data,dataindex) in dataBaseDic"
            :key="dataindex"
          >
            <h6 class="m-0 d-flex float-left">
              <div class="title" :title="data.cluName">
                <span
                  :class="data.status?'text-primary':''"
                  @click="clickcheckAll(dataindex)"
                >{{data.cluName}}</span>
              </div>
              <span class="px-1">></span>
            </h6>
            <div class="clearfix library-content">
              <div
                class="float-left pl-1 alarm-item"
                v-for="(item,index) in data.dblist"
                :key="index"
              >
                <span class="border-left px-1"></span>
                <div class="alarm-icon" v-if="item.personIsHub==='1'">
                  <span class="f10 font-weight-bolder">!</span>
                </div>
                <a
                  :title="item.baseValue"
                  :class="['alarm-name',item && item.status ?'active':'']"
                  @click="setSelectLibrary({ index, val:!!item.status},dataindex,'radio');recordType = 'dataBase'"
                >{{item.baseValue}}</a>
              </div>
            </div>
          </div>
          <div class="py-1 text-right" v-if="dataBaseDic.length">
            <b-btn variant="primary" class="mr10" @click="isCheckBox=!isCheckBox">多选</b-btn>
          </div>
        </el-form-item>
        <!-- 单选状态显示 end -->
      </el-form>
    </div>
  </select-king>
</template>
<script>
import selectKing from '@/components/selectKing'
import { FormItem, Form, CheckboxGroup, Checkbox } from 'element-ui'
import { getAllDataBaseDic } from '@/server/common.js'
export default {
  name: 'typeLibrary',
  components: {
    elFormItem: FormItem,
    elCheckboxGroup: CheckboxGroup,
    elCheckbox: Checkbox,
    elForm: Form,
    selectKing
  },
  data() {
    return {
      isCheckBox: false,
      selectVal: '全部记录', // select 显示值
      recordType: '', // 按类型传值, '选择库后为dataBase'
      dataBaseList: [], // 底库集合

      recordList: [
        {
          name: '全部记录',
          value: ''
        },
        {
          name: '报警记录',
          value: 'alarm'
        },
        {
          name: '其他库记录',
          value: 'other'
        }
      ],
      dataBaseDic: [],
      dataBaseDicCheck: []
    }
  },
  computed: {},
  methods: {
    // 获取数据
    async initData() {
      const res = await getAllDataBaseDic()
      if (res && res.success && res.data) {
        this.dataBaseDic = [...JSON.parse(JSON.stringify(res.data))]
        this.dataBaseDicCheck = [...JSON.parse(JSON.stringify(res.data))]
      }
    },
    setSelect(item) {
      // 初始化 地库
      this.dataBaseDic.map((val, dataindex) => {
        const jsonArr = this.setViewLibrary('NULL', dataindex)
        this.dataBaseDicCheck = [...jsonArr]
        this.dataBaseDic = [...jsonArr]
      })
      this.recordType = item.value
      // 提交数据
      this.emitData()
    },
    /* 多选视图操作 start */
    checkAll(val, dataindex) {
      let jsonArr = []
      if (val) {
        // 全选 'ALL'
        jsonArr = this.setViewLibrary('ALL', dataindex)
      } else {
        // 取消全选 传入任意字符串
        jsonArr = this.setViewLibrary('NULL', dataindex)
      }
      this.dataBaseDicCheck = [...jsonArr]
      return true
    },
    setSelectLibrary({ index, val }, dataindex, type) {
      const jsonArr = this.setViewLibrary({ index, val, type }, dataindex)
      if (type === 'radio') {
        // 单选选择库
        this.dataBaseDic = [...jsonArr]
        this.dataBaseDicCheck = [...jsonArr]
        // 设置类型值
        this.recordType = 'dataBase'
        // 提交数据
        this.emitData()
      } else {
        this.dataBaseDicCheck = [...jsonArr]
      }
    },
    // 赋值给选择视图 公共方法
    setViewLibrary(res, dataindex) {
      const jsonArr = JSON.parse(JSON.stringify(this.dataBaseDicCheck))
      if (!dataindex && dataindex !== 0) {
        return jsonArr
      }
      const { index, val, type = 'checkBox' } = res
      if (
        jsonArr.length &&
        jsonArr[dataindex].dblist &&
        jsonArr[dataindex].dblist.length
      ) {
        const dblist = jsonArr[dataindex].dblist
        // res === 'NULL' res === 'ALL'
        if (typeof res === 'string') {
          dblist.map((iteam, n) => {
            // 设置全选或者取消全部
            dblist[n].status = res === 'ALL'
            jsonArr[dataindex].status = res === 'ALL'
          })
        } else {
          if (type === 'radio') {
            jsonArr.map((item, dataindex) => {
              let dblist = jsonArr[dataindex].dblist
                ? jsonArr[dataindex].dblist
                : []
              dblist.map((iteam, index) => {
                dblist[index].status = false
                return iteam
              })
              return item
            })
            dblist[index].status = true
          } else {
            dblist[index].status = !val
          }
          // 是否勾选全选
          jsonArr.map((iteam, n) => {
            const checkList = iteam.dblist.filter(item => item.status)
            iteam.status = checkList.length === iteam.dblist.length
          })
        }
      }
      return jsonArr
    },
    submitCheck() {
      let dataBaseList = []
      this.dataBaseDicCheck.map(iteam => {
        const list = iteam.dblist ? iteam.dblist : []
        list
          .filter(item => item && item.status)
          .map(item => {
            item.baseName && dataBaseList.push(item.baseName)
          })
      })
      if (!dataBaseList.length) {
        this.$toast({
          type: 'error',
          message: '您至少选择一项'
        })
        return false
      }
      const jsonArr = JSON.parse(JSON.stringify(this.dataBaseDicCheck))
      this.dataBaseDic = [...jsonArr]
      this.isCheckBox = false
      // 设置类型值
      this.recordType = 'dataBase'
      // 提交数据
      this.emitData()
    },
    cancel() {
      const jsonArr = JSON.parse(JSON.stringify(this.dataBaseDic))
      // 初始化全选
      // jsonArr.map(item => {
      //   const len = item.dblist.length
      //   const itam = item.dblist
      //   // 得到选中的数组
      //   const checkList = itam.filter(item => item.status)
      //   item.status = checkList.length === len
      // })
      this.dataBaseDicCheck = [...jsonArr]
      this.isCheckBox = false
    },
    /* 多选视图操作 end */
    async clickcheckAll(dataindex) {
      const res = await this.checkAll(true, dataindex)
      if (res) {
        this.submitCheck()
      }
    },
    emitData() {
      // 根据记录选择值
      let valNames = []
      let dataBaseList = []
      if (this.recordType === 'dataBase') {
        // 选择底库的情况
        this.dataBaseDic.map(iteam => {
          const list = iteam.dblist ? iteam.dblist : []
          list
            .filter(item => item && item.status)
            .map(item => {
              item.baseName && dataBaseList.push(item.baseName)
              item.baseValue && valNames.push(item.baseValue)
            })
        })
      } else {
        // 选择类型的情况
        valNames = this.recordList
          .filter(item => item.value === this.recordType)
          .map(item => (item && item.name ? item.name : ''))
      }
      // 设置selcet val显示
      this.selectVal = valNames.join('/')
      // 关闭下拉
      this.$refs.selectKing.close()
      // 拼接实际value
      const json = {
        valNames,
        dataBaseList,
        recordType: this.recordType !== 'dataBase' ? this.recordType : '',
        data: this.dataBaseDic
      }
      this.$emit('submitData', json)
    },
    init() {
      this.recordType = ''
      this.emitData()
    }
  },
  created() {
    this.initData()
  },
  watch: {}
}
</script>
<style lang="scss" scoped>
.type-library {
  .select-liby {
    padding: 2px 10px 2px 0;
    line-height: 30px;
    height: 30px;
    a {
      cursor: pointer;
    }
    a.active {
      font-weight: 600;
      text-decoration: underline;
    }
    a:hover {
      color: #ccc;
    }
    a.active:hover {
      color: #333;
    }
  }
}
.library-list {
  h6 {
    height: 30px;
    line-height: 30px;
    width: 80px;
    cursor: pointer;
    .title {
      display: block;
      width: 60px;
      overflow: hidden;
      text-overflow: ellipsis;
      white-space: nowrap;
    }
  }
  .library-content {
    margin-left: 80px;
  }
  .alarm-item {
    line-height: 30px;
    .alarm-icon {
      display: inline-block;
      vertical-align: middle;
      width: 15px;
      height: 15px;
      line-height: 15px;
      background: #d9534f;
      border-radius: 50%;
      overflow: hidden;
      text-align: center;
      color: #fff;
    }
    .alarm-name {
      display: inline-block;
      vertical-align: middle;
      line-height: 15px;
      padding: 2px 4px;
      max-width: 100px;
      cursor: pointer;
      overflow: hidden;
      text-overflow: ellipsis;
      white-space: nowrap;
    }
    .alarm-name.active {
      background: #35bde7;
      color: #fff;
    }
  }
}
</style>
